#include "gdbm-wrapper.h"

int gdbmw_store (GDBM_FILE a1, char *a2a, int a2b, char *a3a, int a3b, int a4) {
  datum a2={a2a, a2b};
  datum a3={a3a, a3b};
  return gdbm_store(a1, a2, a3, a4);
}

char * gdbmw_fetch (GDBM_FILE a1, char *a2a, int a2b, int *rl) {
  datum a2={a2a, a2b};
  datum r=gdbm_fetch(a1, a2);
  *rl=r.dsize;
  return r.dptr;
}

int gdbmw_delete (GDBM_FILE a1, char *a2a, int a2b) {
  datum a2={a2a, a2b};
  return gdbm_delete(a1, a2);
}

char * gdbmw_firstkey (GDBM_FILE a1, int *rl) {
  datum r=gdbm_firstkey(a1);
  *rl=r.dsize;
  return r.dptr;
}

char * gdbmw_nextkey (GDBM_FILE a1, char *a2a, int a2b, int *rl) {
  datum a2={a2a, a2b};
  datum r=gdbm_nextkey(a1, a2);
  *rl=r.dsize;
  return r.dptr;
}

int gdbmw_exists (GDBM_FILE a1, char *a2a, int a2b) {
  datum a2={a2a, a2b};
  return gdbm_exists(a1, a2);
}
