/*

	This build file does nothing more than autobuild, but since autobuild
	uses the os module, using autobuild here would result in cylic dependencies
	in the build process.

*/

module.include("C");

if (!os.access("clib"+os.dlext,os.R_OK)) {

	_.puts("Compiling clib.c");

	if (global._WIN32)
		os.system('cl /nologo /Tc clib.c ..\\C\\js32.lib ..\\C\\callc.lib /MD /LD /Feclib.dll');
	else
		os.system("cc -g clib.c -o clib.so --shared");
}

if (!os.access("clib.h"+os.dlext,os.R_OK)) {
	_.puts("Building wrapper for clib.h");

	headerfile=_.fopen("clib.h","r");
	header=new Pointer(1024*100);
	len=_.fread(header,1,1024*100,headerfile);
	_.fclose(headerfile);
	header=header.string(len);
	default_dl=dl(os.curdir+os.sep+"clib"+os.dlext);

	wrapper=C.C_wrapper(header,default_dl);

	wrapperfile=_.fopen("clib.h.cdbg","w");
	_.fwrite(wrapper,wrapper.length,1,wrapperfile);
	_.fclose(wrapperfile);

	if (global._WIN32)
		os.system('cl /nologo /Tc clib.h.cdbg ..\\C\\js32.lib ..\\C\\callc.lib /MD /LD /Feclib.h.dll');
	else
		os.system("cc -g -x c clib.h.cdbg -o clib.h.so --shared");
}


