RICHEDIT.initfunc=function() {
	dl("Riched20.dll");
}

RICHEDIT.prototype.CHARFROMPOS=EDIT.prototype.CHARFROMPOS;
RICHEDIT.prototype.GETLINE=EDIT.prototype.GETLINE;
RICHEDIT.prototype.REPLACESEL=EDIT.prototype.REPLACESEL;

RICHEDIT.prototype.EXLINEFROMCHAR=function(CharPos) {
	return _.SendMessage(this.Wnd, _.EM_EXLINEFROMCHAR, 0, CharPos);
}

RICHEDIT.prototype.LINEFROMCHAR=RICHEDIT.prototype.EXLINEFROMCHAR;

RICHEDIT.prototype.EXGETSEL=function() {
	var chr=Pointer(_.CHARRANGE);
	_.SendMessage(this.Wnd, _.EM_EXGETSEL, 0, chr);
	chr=chr.get();
	return [chr.cpMin, chr.cpMax];
}

RICHEDIT.prototype.GETSEL=RICHEDIT.prototype.EXGETSEL;

RICHEDIT.prototype.EXLIMITTEXT=function(max) {
	_.SendMessage(this.Wnd, _.EM_EXLIMITTEXT, 0, max);
}

RICHEDIT.prototype.LIMITTEXT=RICHEDIT.prototype.EXLIMITTEXT;

RICHEDIT.prototype.EXSETSEL=function(Min, Max) {
	var chr=Pointer(_.CHARRANGE);
	chr.cpMin=Min;
	chr.cpMax=Max;
	return _.SendMessage(this.Wnd, _.EM_EXSETSEL, 0, chr);
}

RICHEDIT.prototype.SETSEL=RICHEDIT.prototype.EXSETSEL;

RICHEDIT.prototype.GETSELTEXT=function() {
	var sel=this.GETSEL();
	var len=sel[1]-sel[0];
	var buflen=(len+1)*windows.CharSize;
	var buf=new Pointer(buflen);
	var len=_.SendMessage(this.Wnd, _.EM_GETSELTEXT, 0, buf);
	return windows.Str.call(buf,len);
}

RICHEDIT.prototype.FINDTEXTEX=function(Str, Options) {
	Options=windows.MergeOptions(Options,
		{
			Min: 0,
			Max: -1,
			Flags: 0
		},
		{Flags: windows.Flags.FR}
	);

	var x=Pointer(_.FINDTEXT);
	x.lpstrText=Str;
	x.chrg={cpMin:Options.Min, cpMax:Options.Max};

	var ret=_.SendMessage(this.Wnd, _.EM_FINDTEXTEX, Options.Flags, x);

	return ret;
}

RICHEDIT.prototype.FINDTEXT=RICHEDIT.prototype.FINDTEXTEX;

RICHEDIT.prototype.FINDWORDBREAK=function(Code, Start) {
	return _.SendMessage(this.Wnd, _.EM_FINDWORDBREAK, windows.Flags.WB[Code], Start);
}


RICHEDIT.prototype.SETBKGNDCOLOR=function(Color) {
	if (Color==undefined)
		return _.SendMessage(this.Wnd, _.EM_SETBKGNDCOLOR, 1,0);
	else {
		return _.SendMessage(this.Wnd, _.EM_SETBKGNDCOLOR, 0, Color);
	}
}

RICHEDIT.UID={};
for (var i in Flags.UID) RICHEDIT.UID[Flags.UID[i]]=i;

RICHEDIT.prototype.GETUNDONAME=function() {
	return RICHEDIT.UID[_.SendMessage(this.Wnd, _.EM_GETUNDONAME, 0, 0)];
}

RICHEDIT.prototype.GETREDONAME=function() {
	return RICHEDIT.UID[_.SendMessage(this.Wnd, _.EM_GETREDONAME, 0, 0)];
}

RICHEDIT.prototype.DISPLAYBAND=function(Rect) {
	var rect=Pointer(_.RECT);
	rect.left=Rect.left;
	rect.right=Rect.right;
	rect.top=Rect.top;
	rect.bottom=Rect.bottom;
	return _.SendMessage(this.Wnd, _.EM_DISPLAYBAND, 0, rect);
}

